#include <amxmodx>
#include <sqlx>

new Handle:g_sql = Empty_Handle;
new fw_load_bonpref;

public plugin_init( )
{
	register_plugin("bonprefs loader", "0.1", "ko1dun");
	
	fw_load_bonpref = CreateMultiForward("fw_load_bonpref", ET_IGNORE, FP_CELL, FP_CELL, FP_STRING, FP_STRING);
	
	new szConfigsDir[64];
	get_localinfo("amxx_configsdir", szConfigsDir, charsmax(szConfigsDir));
	
	server_cmd("exec %s/sql.cfg", szConfigsDir);
	server_exec();
	
	new error[128], res;
	g_sql = SQL_MakeStdTuple()
	new Handle:sql = SQL_Connect(g_sql, res, error, charsmax(error))
	
	if( sql == Empty_Handle )
	{
		log_amx( "[SQLX sql error] %s ", error );
		g_sql = Empty_Handle;
		return PLUGIN_CONTINUE;
	}
	
	SQL_FreeHandle( sql );
	SQL_SetCharset( g_sql, "utf8" );
	SQL_ThreadQuery( g_sql, "QueryHandler", "CREATE TABLE IF NOT EXISTS `bonpref_module` (\
		`id` int(11) NOT NULL AUTO_INCREMENT,\
		`user_id` int(3) NOT NULL DEFAULT '0',\
		`authid` varchar(32) NOT NULL,\
		`efield` varchar(32) NOT NULL,\
		`etype` varchar(32) NOT NULL,\
		`estate` int(11) NOT NULL DEFAULT '0',\
		`created_date` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP,\
		`expire_date` timestamp NULL DEFAULT NULL,\
		PRIMARY KEY (`id`)\
	) ENGINE=InnoDB DEFAULT CHARSET=utf8;");
	
	return PLUGIN_CONTINUE;
}

public client_putinserver( id ) {
	new szQuery[256], cData[1], steam[MAX_AUTHID_LENGTH];
	get_user_authid( id, steam, charsmax(steam) ); cData[0] = id;
	formatex(szQuery, charsmax(szQuery),
		"SELECT * FROM `bonpref_module` WHERE \
		`authid` = '%s' AND `estate` != 0 \
		AND (`expire_date` > FROM_UNIXTIME('%d') OR `expire_date` IS NULL)",
		steam, get_systime()
	)
	SQL_ThreadQuery(g_sql, "SqlLoad", szQuery, cData, sizeof cData);
}

public QueryHandler(failstate, Handle:query, error[], errnum, data[], size, Float:queuetime) {
	if(failstate != TQUERY_SUCCESS)
	{
		log_amx("QueryHandler(): %s %d", error, errnum)
	}
}

public SqlLoad(failstate, Handle:query, error[], errnum, data[], size, Float:queuetime)
{
	if( failstate != TQUERY_SUCCESS ) {
		log_amx("SqlLoad() %s %d", error, errnum)
		return
	}

	new id = data[0];
	if( !is_user_connected(id) ) {
		return
	}
	
	new ret;
	if( !SQL_NumRows(query) ) {
		ExecuteForward( fw_load_bonpref, ret, id, 0, "0", "[all]" );
		return
	}
	
	new field_id, field_str[32], field_type[32];
	
	while(SQL_MoreResults(query))
	{
		field_id = SQL_ReadResult( query, SQL_FieldNameToNum(query, "id") );
		SQL_ReadResult(query, SQL_FieldNameToNum(query, "efield"), field_str, charsmax(field_str))
		SQL_ReadResult(query, SQL_FieldNameToNum(query, "etype"), field_type, charsmax(field_type))
		ExecuteForward( fw_load_bonpref, ret, id, field_id, field_str, field_type );
		
		SQL_NextRow( query );
	}
}

public plugin_natives()
{
	register_native("used_bonpref", "native_used_bonpref", true);
}

public native_used_bonpref( id, field_id )
{
	new szQuery[72];
	formatex(szQuery, charsmax(szQuery), "UPDATE `bonpref_module` SET `estate`=1 WHERE `id` = %i", field_id )
	SQL_ThreadQuery( g_sql, "SqlUpdate", szQuery );
}

public SqlUpdate(failstate, Handle:query, error[], errnum, data[], size, Float:queuetime)
{
	if( failstate != TQUERY_SUCCESS ) {
		log_amx("SqlUpdate() %s %d", error, errnum);
	}
}

public plugin_end()
{
	SQL_FreeHandle(g_sql)
}